/*!
 * @copyright Copyright &copy; Kartik Visweswaran, Krajee.com, 2014 - 2016
 * @version 1.3.4
 *
 * Date formatter utility library that allows formatting date/time variables or Date objects using PHP DateTime format.
 * @see http://php.net/manual/en/function.date.php
 *
 * For more JQuery plugins visit http://plugins.krajee.com
 * For more Yii related demos visit http://demos.krajee.com
 */
;var DateFormatter;!function(){'use strict';var t,e,a,n,o,r,i;r=864e5,i=3600,t=function(e,t){return'string'==typeof e&&'string'==typeof t&&e.toLowerCase()===t.toLowerCase()},e=function(t,a,n){var i=n||'0',r=t.toString();return r.length<a?e(i+r,a):r},a=function(e){var r,n;for(e=e||{},r=1;r<arguments.length;r++)if(n=arguments[r])for(var t in n)n.hasOwnProperty(t)&&('object'==typeof n[t]?a(e[t],n[t]):e[t]=n[t]);return e},n=function(e,t){for(var a=0;a<t.length;a++)if(t[a].toLowerCase()===e.toLowerCase())return a;return-1},o={dateSettings:{days:['Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday'],daysShort:['Sun','Mon','Tue','Wed','Thu','Fri','Sat'],months:['January','February','March','April','May','June','July','August','September','October','November','December'],monthsShort:['Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec'],meridiem:['AM','PM'],ordinal:function(e){var t=e%10,a={1:'st',2:'nd',3:'rd'};return 1!==Math.floor(e%100/10)&&a[t]?a[t]:'th'}},separators:/[ \-+\/\.T:@]/g,validParts:/[dDjlNSwzWFmMntLoYyaABgGhHisueTIOPZcrU]/g,intParts:/[djwNzmnyYhHgGis]/g,tzParts:/\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g,tzClip:/[^-+\dA-Z]/g},DateFormatter=function(e){var t=this,n=a(o,e);t.dateSettings=n.dateSettings,t.separators=n.separators,t.validParts=n.validParts,t.intParts=n.intParts,t.tzParts=n.tzParts,t.tzClip=n.tzClip},DateFormatter.prototype={constructor:DateFormatter,getMonth:function(e){var t,a=this;return t=n(e,a.dateSettings.monthsShort)+1,0===t&&(t=n(e,a.dateSettings.months)+1),t},parseDate:function(e,n){var i,d,o,s,a,c,m,h,p,g,f=this,l=!1,u=!1,D=f.dateSettings,r={date:null,year:null,month:null,day:null,hour:0,min:0,sec:0};if(!e)return null;if(e instanceof Date)return e;if('U'===n)return o=parseInt(e),o?new Date(1e3*o):e;switch(typeof e){case'number':return new Date(e);case'string':break;default:return null};if(i=n.match(f.validParts),!i||0===i.length)throw new Error('Invalid date format definition.');for(d=e.replace(f.separators,'\x00').split('\x00'),o=0;o<d.length;o++)switch(s=d[o],a=parseInt(s),i[o]){case'y':case'Y':if(!a)return null;p=s.length,r.year=2===p?parseInt((70>a?'20':'19')+s):a,l=!0;break;case'm':case'n':case'M':case'F':if(isNaN(a)){if(c=f.getMonth(s),!(c>0))return null;r.month=c}
else{if(!(a>=1&&12>=a))return null;r.month=a};l=!0;break;case'd':case'j':if(!(a>=1&&31>=a))return null;r.day=a,l=!0;break;case'g':case'h':if(m=i.indexOf('a')>-1?i.indexOf('a'):i.indexOf('A')>-1?i.indexOf('A'):-1,g=d[m],m>-1)h=t(g,D.meridiem[0])?0:t(g,D.meridiem[1])?12:-1,a>=1&&12>=a&&h>-1?r.hour=a+h-1:a>=0&&23>=a&&(r.hour=a);else{if(!(a>=0&&23>=a))return null;r.hour=a};u=!0;break;case'G':case'H':if(!(a>=0&&23>=a))return null;r.hour=a,u=!0;break;case'i':if(!(a>=0&&59>=a))return null;r.min=a,u=!0;break;case's':if(!(a>=0&&59>=a))return null;r.sec=a,u=!0};if(l===!0&&r.year&&r.month&&r.day)r.date=new Date(r.year,r.month-1,r.day,r.hour,r.min,r.sec,0);else{if(u!==!0)return null;r.date=new Date(0,0,0,r.hour,r.min,r.sec,0)};return r.date},guessDate:function(e,t){if('string'!=typeof e)return e;var o,s,r,d,i,n,c=this,f=e.replace(c.separators,'\x00').split('\x00'),m=/^[djmn]/g,u=t.match(c.validParts),a=new Date,l=0;if(!m.test(u[0]))return e;for(r=0;r<f.length;r++){if(l=2,i=f[r],n=parseInt(i.substr(0,2)),isNaN(n))return null;switch(r){case 0:'m'===u[0]||'n'===u[0]?a.setMonth(n-1):a.setDate(n);break;case 1:'m'===u[0]||'n'===u[0]?a.setDate(n):a.setMonth(n-1);break;case 2:if(s=a.getFullYear(),o=i.length,l=4>o?o:4,s=parseInt(4>o?s.toString().substr(0,4-o)+i:i.substr(0,4)),!s)return null;a.setFullYear(s);break;case 3:a.setHours(n);break;case 4:a.setMinutes(n);break;case 5:a.setSeconds(n)};d=i.substr(l),d.length>0&&f.splice(r+1,0,d)};return a},parseFormat:function(t,a){var n,s=this,o=s.dateSettings,d=/\\?(.?)/gi,u=function(e,t){return n[e]?n[e]():t};return n={d:function(){return e(n.j(),2)},D:function(){return o.daysShort[n.w()]},j:function(){return a.getDate()},l:function(){return o.days[n.w()]},N:function(){return n.w()||7},w:function(){return a.getDay()},z:function(){var e=new Date(n.Y(),n.n()-1,n.j()),t=new Date(n.Y(),0,1);return Math.round((e-t)/r)},W:function(){var t=new Date(n.Y(),n.n()-1,n.j()-n.N()+3),a=new Date(t.getFullYear(),0,4);return e(1+Math.round((t-a)/r/7),2)},F:function(){return o.months[a.getMonth()]},m:function(){return e(n.n(),2)},M:function(){return o.monthsShort[a.getMonth()]},n:function(){return a.getMonth()+1},t:function(){return new Date(n.Y(),n.n(),0).getDate()},L:function(){var e=n.Y();return e%4===0&&e%100!==0||e%400===0?1:0},o:function(){var e=n.n(),t=n.W(),a=n.Y();return a+(12===e&&9>t?1:1===e&&t>9?-1:0)},Y:function(){return a.getFullYear()},y:function(){return n.Y().toString().slice(-2)},a:function(){return n.A().toLowerCase()},A:function(){var e=n.G()<12?0:1;return o.meridiem[e]},B:function(){var t=a.getUTCHours()*i,n=60*a.getUTCMinutes(),r=a.getUTCSeconds();return e(Math.floor((t+n+r+i)/86.4)%1e3,3)},g:function(){return n.G()%12||12},G:function(){return a.getHours()},h:function(){return e(n.g(),2)},H:function(){return e(n.G(),2)},i:function(){return e(a.getMinutes(),2)},s:function(){return e(a.getSeconds(),2)},u:function(){return e(1e3*a.getMilliseconds(),6)},e:function(){var e=/\((.*)\)/.exec(String(a))[1];return e||'Coordinated Universal Time'},I:function(){var e=new Date(n.Y(),0),t=Date.UTC(n.Y(),0),a=new Date(n.Y(),6),r=Date.UTC(n.Y(),6);return e-t!==a-r?1:0},O:function(){var t=a.getTimezoneOffset(),n=Math.abs(t);return(t>0?'-':'+')+e(100*Math.floor(n/60)+n%60,4)},P:function(){var e=n.O();return e.substr(0,3)+':'+e.substr(3,2)},T:function(){var e=(String(a).match(s.tzParts)||['']).pop().replace(s.tzClip,'');return e||'UTC'},Z:function(){return 60*-a.getTimezoneOffset()},c:function(){return'Y-m-d\\TH:i:sP'.replace(d,u)},r:function(){return'D, d M Y H:i:s O'.replace(d,u)},U:function(){return a.getTime()/1e3||0}},u(t,t)},formatDate:function(e,t){var a,u,o,r,n,i=this,s='',d='\\';if('string'==typeof e&&(e=i.parseDate(e,t),!e))return null;if(e instanceof Date){for(o=t.length,a=0;o>a;a++)n=t.charAt(a),'S'!==n&&n!==d&&(a>0&&t.charAt(a-1)===d?s+=n:(r=i.parseFormat(n,e),a!==o-1&&i.intParts.test(n)&&'S'===t.charAt(a+1)&&(u=parseInt(r)||0,r+=i.dateSettings.ordinal(u)),s+=r));return s};return''}}}();var datetimepickerFactory=function(e){'use strict';var n={i18n:{ar:{months:['كانون الثاني','شباط','آذار','نيسان','مايو','حزيران','تموز','آب','أيلول','تشرين الأول','تشرين الثاني','كانون الأول'],dayOfWeekShort:['ن','ث','ع','خ','ج','س','ح'],dayOfWeek:['الأحد','الاثنين','الثلاثاء','الأربعاء','الخميس','الجمعة','السبت','الأحد']},ro:{months:['Ianuarie','Februarie','Martie','Aprilie','Mai','Iunie','Iulie','August','Septembrie','Octombrie','Noiembrie','Decembrie'],dayOfWeekShort:['Du','Lu','Ma','Mi','Jo','Vi','Sâ'],dayOfWeek:['Duminică','Luni','Marţi','Miercuri','Joi','Vineri','Sâmbătă']},id:{months:['Januari','Februari','Maret','April','Mei','Juni','Juli','Agustus','September','Oktober','November','Desember'],dayOfWeekShort:['Min','Sen','Sel','Rab','Kam','Jum','Sab'],dayOfWeek:['Minggu','Senin','Selasa','Rabu','Kamis','Jumat','Sabtu']},is:{months:['Janúar','Febrúar','Mars','Apríl','Maí','Júní','Júlí','Ágúst','September','Október','Nóvember','Desember'],dayOfWeekShort:['Sun','Mán','Þrið','Mið','Fim','Fös','Lau'],dayOfWeek:['Sunnudagur','Mánudagur','Þriðjudagur','Miðvikudagur','Fimmtudagur','Föstudagur','Laugardagur']},bg:{months:['Януари','Февруари','Март','Април','Май','Юни','Юли','Август','Септември','Октомври','Ноември','Декември'],dayOfWeekShort:['Нд','Пн','Вт','Ср','Чт','Пт','Сб'],dayOfWeek:['Неделя','Понеделник','Вторник','Сряда','Четвъртък','Петък','Събота']},fa:{months:['فروردین','اردیبهشت','خرداد','تیر','مرداد','شهریور','مهر','آبان','آذر','دی','بهمن','اسفند'],dayOfWeekShort:['یکشنبه','دوشنبه','سه شنبه','چهارشنبه','پنجشنبه','جمعه','شنبه'],dayOfWeek:['یک‌شنبه','دوشنبه','سه‌شنبه','چهارشنبه','پنج‌شنبه','جمعه','شنبه','یک‌شنبه']},ru:{months:['Январь','Февраль','Март','Апрель','Май','Июнь','Июль','Август','Сентябрь','Октябрь','Ноябрь','Декабрь'],dayOfWeekShort:['Вс','Пн','Вт','Ср','Чт','Пт','Сб'],dayOfWeek:['Воскресенье','Понедельник','Вторник','Среда','Четверг','Пятница','Суббота']},uk:{months:['Січень','Лютий','Березень','Квітень','Травень','Червень','Липень','Серпень','Вересень','Жовтень','Листопад','Грудень'],dayOfWeekShort:['Ндл','Пнд','Втр','Срд','Чтв','Птн','Сбт'],dayOfWeek:['Неділя','Понеділок','Вівторок','Середа','Четвер','П\'ятниця','Субота']},en:{months:['January','February','March','April','May','June','July','August','September','October','November','December'],dayOfWeekShort:['Sun','Mon','Tue','Wed','Thu','Fri','Sat'],dayOfWeek:['Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday']},el:{months:['Ιανουάριος','Φεβρουάριος','Μάρτιος','Απρίλιος','Μάιος','Ιούνιος','Ιούλιος','Αύγουστος','Σεπτέμβριος','Οκτώβριος','Νοέμβριος','Δεκέμβριος'],dayOfWeekShort:['Κυρ','Δευ','Τρι','Τετ','Πεμ','Παρ','Σαβ'],dayOfWeek:['Κυριακή','Δευτέρα','Τρίτη','Τετάρτη','Πέμπτη','Παρασκευή','Σάββατο']},de:{months:['Januar','Februar','März','April','Mai','Juni','Juli','August','September','Oktober','November','Dezember'],dayOfWeekShort:['So','Mo','Di','Mi','Do','Fr','Sa'],dayOfWeek:['Sonntag','Montag','Dienstag','Mittwoch','Donnerstag','Freitag','Samstag']},nl:{months:['januari','februari','maart','april','mei','juni','juli','augustus','september','oktober','november','december'],dayOfWeekShort:['zo','ma','di','wo','do','vr','za'],dayOfWeek:['zondag','maandag','dinsdag','woensdag','donderdag','vrijdag','zaterdag']},tr:{months:['Ocak','Şubat','Mart','Nisan','Mayıs','Haziran','Temmuz','Ağustos','Eylül','Ekim','Kasım','Aralık'],dayOfWeekShort:['Paz','Pts','Sal','Çar','Per','Cum','Cts'],dayOfWeek:['Pazar','Pazartesi','Salı','Çarşamba','Perşembe','Cuma','Cumartesi']},fr:{months:['Janvier','Février','Mars','Avril','Mai','Juin','Juillet','Août','Septembre','Octobre','Novembre','Décembre'],dayOfWeekShort:['Dim','Lun','Mar','Mer','Jeu','Ven','Sam'],dayOfWeek:['dimanche','lundi','mardi','mercredi','jeudi','vendredi','samedi']},es:{months:['Enero','Febrero','Marzo','Abril','Mayo','Junio','Julio','Agosto','Septiembre','Octubre','Noviembre','Diciembre'],dayOfWeekShort:['Dom','Lun','Mar','Mié','Jue','Vie','Sáb'],dayOfWeek:['Domingo','Lunes','Martes','Miércoles','Jueves','Viernes','Sábado']},th:{months:['มกราคม','กุมภาพันธ์','มีนาคม','เมษายน','พฤษภาคม','มิถุนายน','กรกฎาคม','สิงหาคม','กันยายน','ตุลาคม','พฤศจิกายน','ธันวาคม'],dayOfWeekShort:['อา.','จ.','อ.','พ.','พฤ.','ศ.','ส.'],dayOfWeek:['อาทิตย์','จันทร์','อังคาร','พุธ','พฤหัส','ศุกร์','เสาร์','อาทิตย์']},pl:{months:['styczeń','luty','marzec','kwiecień','maj','czerwiec','lipiec','sierpień','wrzesień','październik','listopad','grudzień'],dayOfWeekShort:['nd','pn','wt','śr','cz','pt','sb'],dayOfWeek:['niedziela','poniedziałek','wtorek','środa','czwartek','piątek','sobota']},pt:{months:['Janeiro','Fevereiro','Março','Abril','Maio','Junho','Julho','Agosto','Setembro','Outubro','Novembro','Dezembro'],dayOfWeekShort:['Dom','Seg','Ter','Qua','Qui','Sex','Sab'],dayOfWeek:['Domingo','Segunda','Terça','Quarta','Quinta','Sexta','Sábado']},ch:{months:['一月','二月','三月','四月','五月','六月','七月','八月','九月','十月','十一月','十二月'],dayOfWeekShort:['日','一','二','三','四','五','六']},se:{months:['Januari','Februari','Mars','April','Maj','Juni','Juli','Augusti','September','Oktober','November','December'],dayOfWeekShort:['Sön','Mån','Tis','Ons','Tor','Fre','Lör']},km:{months:['មករា​','កុម្ភៈ','មិនា​','មេសា​','ឧសភា​','មិថុនា​','កក្កដា​','សីហា​','កញ្ញា​','តុលា​','វិច្ឆិកា','ធ្នូ​'],dayOfWeekShort:['អាទិ​','ច័ន្ទ​','អង្គារ​','ពុធ​','ព្រហ​​','សុក្រ​','សៅរ៍'],dayOfWeek:['អាទិត្យ​','ច័ន្ទ​','អង្គារ​','ពុធ​','ព្រហស្បតិ៍​','សុក្រ​','សៅរ៍']},kr:{months:['1월','2월','3월','4월','5월','6월','7월','8월','9월','10월','11월','12월'],dayOfWeekShort:['일','월','화','수','목','금','토'],dayOfWeek:['일요일','월요일','화요일','수요일','목요일','금요일','토요일']},it:{months:['Gennaio','Febbraio','Marzo','Aprile','Maggio','Giugno','Luglio','Agosto','Settembre','Ottobre','Novembre','Dicembre'],dayOfWeekShort:['Dom','Lun','Mar','Mer','Gio','Ven','Sab'],dayOfWeek:['Domenica','Lunedì','Martedì','Mercoledì','Giovedì','Venerdì','Sabato']},da:{months:['Januar','Februar','Marts','April','Maj','Juni','Juli','August','September','Oktober','November','December'],dayOfWeekShort:['Søn','Man','Tir','Ons','Tor','Fre','Lør'],dayOfWeek:['søndag','mandag','tirsdag','onsdag','torsdag','fredag','lørdag']},no:{months:['Januar','Februar','Mars','April','Mai','Juni','Juli','August','September','Oktober','November','Desember'],dayOfWeekShort:['Søn','Man','Tir','Ons','Tor','Fre','Lør'],dayOfWeek:['Søndag','Mandag','Tirsdag','Onsdag','Torsdag','Fredag','Lørdag']},ja:{months:['1月','2月','3月','4月','5月','6月','7月','8月','9月','10月','11月','12月'],dayOfWeekShort:['日','月','火','水','木','金','土'],dayOfWeek:['日曜','月曜','火曜','水曜','木曜','金曜','土曜']},vi:{months:['Tháng 1','Tháng 2','Tháng 3','Tháng 4','Tháng 5','Tháng 6','Tháng 7','Tháng 8','Tháng 9','Tháng 10','Tháng 11','Tháng 12'],dayOfWeekShort:['CN','T2','T3','T4','T5','T6','T7'],dayOfWeek:['Chủ nhật','Thứ hai','Thứ ba','Thứ tư','Thứ năm','Thứ sáu','Thứ bảy']},sl:{months:['Januar','Februar','Marec','April','Maj','Junij','Julij','Avgust','September','Oktober','November','December'],dayOfWeekShort:['Ned','Pon','Tor','Sre','Čet','Pet','Sob'],dayOfWeek:['Nedelja','Ponedeljek','Torek','Sreda','Četrtek','Petek','Sobota']},cs:{months:['Leden','Únor','Březen','Duben','Květen','Červen','Červenec','Srpen','Září','Říjen','Listopad','Prosinec'],dayOfWeekShort:['Ne','Po','Út','St','Čt','Pá','So']},hu:{months:['Január','Február','Március','Április','Május','Június','Július','Augusztus','Szeptember','Október','November','December'],dayOfWeekShort:['Va','Hé','Ke','Sze','Cs','Pé','Szo'],dayOfWeek:['vasárnap','hétfő','kedd','szerda','csütörtök','péntek','szombat']},az:{months:['Yanvar','Fevral','Mart','Aprel','May','Iyun','Iyul','Avqust','Sentyabr','Oktyabr','Noyabr','Dekabr'],dayOfWeekShort:['B','Be','Ça','Ç','Ca','C','Ş'],dayOfWeek:['Bazar','Bazar ertəsi','Çərşənbə axşamı','Çərşənbə','Cümə axşamı','Cümə','Şənbə']},bs:{months:['Januar','Februar','Mart','April','Maj','Jun','Jul','Avgust','Septembar','Oktobar','Novembar','Decembar'],dayOfWeekShort:['Ned','Pon','Uto','Sri','Čet','Pet','Sub'],dayOfWeek:['Nedjelja','Ponedjeljak','Utorak','Srijeda','Četvrtak','Petak','Subota']},ca:{months:['Gener','Febrer','Març','Abril','Maig','Juny','Juliol','Agost','Setembre','Octubre','Novembre','Desembre'],dayOfWeekShort:['Dg','Dl','Dt','Dc','Dj','Dv','Ds'],dayOfWeek:['Diumenge','Dilluns','Dimarts','Dimecres','Dijous','Divendres','Dissabte']},'en-GB':{months:['January','February','March','April','May','June','July','August','September','October','November','December'],dayOfWeekShort:['Sun','Mon','Tue','Wed','Thu','Fri','Sat'],dayOfWeek:['Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday']},et:{months:['Jaanuar','Veebruar','Märts','Aprill','Mai','Juuni','Juuli','August','September','Oktoober','November','Detsember'],dayOfWeekShort:['P','E','T','K','N','R','L'],dayOfWeek:['Pühapäev','Esmaspäev','Teisipäev','Kolmapäev','Neljapäev','Reede','Laupäev']},eu:{months:['Urtarrila','Otsaila','Martxoa','Apirila','Maiatza','Ekaina','Uztaila','Abuztua','Iraila','Urria','Azaroa','Abendua'],dayOfWeekShort:['Ig.','Al.','Ar.','Az.','Og.','Or.','La.'],dayOfWeek:['Igandea','Astelehena','Asteartea','Asteazkena','Osteguna','Ostirala','Larunbata']},fi:{months:['Tammikuu','Helmikuu','Maaliskuu','Huhtikuu','Toukokuu','Kesäkuu','Heinäkuu','Elokuu','Syyskuu','Lokakuu','Marraskuu','Joulukuu'],dayOfWeekShort:['Su','Ma','Ti','Ke','To','Pe','La'],dayOfWeek:['sunnuntai','maanantai','tiistai','keskiviikko','torstai','perjantai','lauantai']},gl:{months:['Xan','Feb','Maz','Abr','Mai','Xun','Xul','Ago','Set','Out','Nov','Dec'],dayOfWeekShort:['Dom','Lun','Mar','Mer','Xov','Ven','Sab'],dayOfWeek:['Domingo','Luns','Martes','Mércores','Xoves','Venres','Sábado']},hr:{months:['Siječanj','Veljača','Ožujak','Travanj','Svibanj','Lipanj','Srpanj','Kolovoz','Rujan','Listopad','Studeni','Prosinac'],dayOfWeekShort:['Ned','Pon','Uto','Sri','Čet','Pet','Sub'],dayOfWeek:['Nedjelja','Ponedjeljak','Utorak','Srijeda','Četvrtak','Petak','Subota']},ko:{months:['1월','2월','3월','4월','5월','6월','7월','8월','9월','10월','11월','12월'],dayOfWeekShort:['일','월','화','수','목','금','토'],dayOfWeek:['일요일','월요일','화요일','수요일','목요일','금요일','토요일']},lt:{months:['Sausio','Vasario','Kovo','Balandžio','Gegužės','Birželio','Liepos','Rugpjūčio','Rugsėjo','Spalio','Lapkričio','Gruodžio'],dayOfWeekShort:['Sek','Pir','Ant','Tre','Ket','Pen','Šeš'],dayOfWeek:['Sekmadienis','Pirmadienis','Antradienis','Trečiadienis','Ketvirtadienis','Penktadienis','Šeštadienis']},lv:{months:['Janvāris','Februāris','Marts','Aprīlis ','Maijs','Jūnijs','Jūlijs','Augusts','Septembris','Oktobris','Novembris','Decembris'],dayOfWeekShort:['Sv','Pr','Ot','Tr','Ct','Pk','St'],dayOfWeek:['Svētdiena','Pirmdiena','Otrdiena','Trešdiena','Ceturtdiena','Piektdiena','Sestdiena']},mk:{months:['јануари','февруари','март','април','мај','јуни','јули','август','септември','октомври','ноември','декември'],dayOfWeekShort:['нед','пон','вто','сре','чет','пет','саб'],dayOfWeek:['Недела','Понеделник','Вторник','Среда','Четврток','Петок','Сабота']},mn:{months:['1-р сар','2-р сар','3-р сар','4-р сар','5-р сар','6-р сар','7-р сар','8-р сар','9-р сар','10-р сар','11-р сар','12-р сар'],dayOfWeekShort:['Дав','Мяг','Лха','Пүр','Бсн','Бям','Ням'],dayOfWeek:['Даваа','Мягмар','Лхагва','Пүрэв','Баасан','Бямба','Ням']},'pt-BR':{months:['Janeiro','Fevereiro','Março','Abril','Maio','Junho','Julho','Agosto','Setembro','Outubro','Novembro','Dezembro'],dayOfWeekShort:['Dom','Seg','Ter','Qua','Qui','Sex','Sáb'],dayOfWeek:['Domingo','Segunda','Terça','Quarta','Quinta','Sexta','Sábado']},sk:{months:['Január','Február','Marec','Apríl','Máj','Jún','Júl','August','September','Október','November','December'],dayOfWeekShort:['Ne','Po','Ut','St','Št','Pi','So'],dayOfWeek:['Nedeľa','Pondelok','Utorok','Streda','Štvrtok','Piatok','Sobota']},sq:{months:['Janar','Shkurt','Mars','Prill','Maj','Qershor','Korrik','Gusht','Shtator','Tetor','Nëntor','Dhjetor'],dayOfWeekShort:['Die','Hën','Mar','Mër','Enj','Pre','Shtu'],dayOfWeek:['E Diel','E Hënë','E Martē','E Mërkurë','E Enjte','E Premte','E Shtunë']},'sr-YU':{months:['Januar','Februar','Mart','April','Maj','Jun','Jul','Avgust','Septembar','Oktobar','Novembar','Decembar'],dayOfWeekShort:['Ned','Pon','Uto','Sre','čet','Pet','Sub'],dayOfWeek:['Nedelja','Ponedeljak','Utorak','Sreda','Četvrtak','Petak','Subota']},sr:{months:['јануар','фебруар','март','април','мај','јун','јул','август','септембар','октобар','новембар','децембар'],dayOfWeekShort:['нед','пон','уто','сре','чет','пет','суб'],dayOfWeek:['Недеља','Понедељак','Уторак','Среда','Четвртак','Петак','Субота']},sv:{months:['Januari','Februari','Mars','April','Maj','Juni','Juli','Augusti','September','Oktober','November','December'],dayOfWeekShort:['Sön','Mån','Tis','Ons','Tor','Fre','Lör'],dayOfWeek:['Söndag','Måndag','Tisdag','Onsdag','Torsdag','Fredag','Lördag']},'zh-TW':{months:['一月','二月','三月','四月','五月','六月','七月','八月','九月','十月','十一月','十二月'],dayOfWeekShort:['日','一','二','三','四','五','六'],dayOfWeek:['星期日','星期一','星期二','星期三','星期四','星期五','星期六']},zh:{months:['一月','二月','三月','四月','五月','六月','七月','八月','九月','十月','十一月','十二月'],dayOfWeekShort:['日','一','二','三','四','五','六'],dayOfWeek:['星期日','星期一','星期二','星期三','星期四','星期五','星期六']},ug:{months:['1-ئاي','2-ئاي','3-ئاي','4-ئاي','5-ئاي','6-ئاي','7-ئاي','8-ئاي','9-ئاي','10-ئاي','11-ئاي','12-ئاي'],dayOfWeek:['يەكشەنبە','دۈشەنبە','سەيشەنبە','چارشەنبە','پەيشەنبە','جۈمە','شەنبە']},he:{months:['ינואר','פברואר','מרץ','אפריל','מאי','יוני','יולי','אוגוסט','ספטמבר','אוקטובר','נובמבר','דצמבר'],dayOfWeekShort:['א\'','ב\'','ג\'','ד\'','ה\'','ו\'','שבת'],dayOfWeek:['ראשון','שני','שלישי','רביעי','חמישי','שישי','שבת','ראשון']},hy:{months:['Հունվար','Փետրվար','Մարտ','Ապրիլ','Մայիս','Հունիս','Հուլիս','Օգոստոս','Սեպտեմբեր','Հոկտեմբեր','Նոյեմբեր','Դեկտեմբեր'],dayOfWeekShort:['Կի','Երկ','Երք','Չոր','Հնգ','Ուրբ','Շբթ'],dayOfWeek:['Կիրակի','Երկուշաբթի','Երեքշաբթի','Չորեքշաբթի','Հինգշաբթի','Ուրբաթ','Շաբաթ']},kg:{months:['Үчтүн айы','Бирдин айы','Жалган Куран','Чын Куран','Бугу','Кулжа','Теке','Баш Оона','Аяк Оона','Тогуздун айы','Жетинин айы','Бештин айы'],dayOfWeekShort:['Жек','Дүй','Шей','Шар','Бей','Жум','Ише'],dayOfWeek:['Жекшемб','Дүйшөмб','Шейшемб','Шаршемб','Бейшемби','Жума','Ишенб']},rm:{months:['Schaner','Favrer','Mars','Avrigl','Matg','Zercladur','Fanadur','Avust','Settember','October','November','December'],dayOfWeekShort:['Du','Gli','Ma','Me','Gie','Ve','So'],dayOfWeek:['Dumengia','Glindesdi','Mardi','Mesemna','Gievgia','Venderdi','Sonda']},ka:{months:['იანვარი','თებერვალი','მარტი','აპრილი','მაისი','ივნისი','ივლისი','აგვისტო','სექტემბერი','ოქტომბერი','ნოემბერი','დეკემბერი'],dayOfWeekShort:['კვ','ორშ','სამშ','ოთხ','ხუთ','პარ','შაბ'],dayOfWeek:['კვირა','ორშაბათი','სამშაბათი','ოთხშაბათი','ხუთშაბათი','პარასკევი','შაბათი']}},ownerDocument:document,contentWindow:window,value:'',rtl:!1,format:'Y/m/d H:i',formatTime:'H:i',formatDate:'Y/m/d',startDate:!1,step:60,monthChangeSpinner:!0,closeOnDateSelect:!1,closeOnTimeSelect:!0,closeOnWithoutClick:!0,closeOnInputClick:!0,openOnFocus:!0,timepicker:!0,datepicker:!0,weeks:!1,defaultTime:!1,defaultDate:!1,minDate:!1,maxDate:!1,minTime:!1,maxTime:!1,minDateTime:!1,maxDateTime:!1,allowTimes:[],opened:!1,initTime:!0,inline:!1,theme:'',touchMovedThreshold:5,onSelectDate:function(){},onSelectTime:function(){},onChangeMonth:function(){},onGetWeekOfYear:function(){},onChangeYear:function(){},onChangeDateTime:function(){},onShow:function(){},onClose:function(){},onGenerate:function(){},withoutCopyright:!0,inverseButton:!1,hours12:!1,next:'xdsoft_next',prev:'xdsoft_prev',dayOfWeekStart:0,parentID:'body',timeHeightInTimePicker:25,timepickerScrollbar:!0,todayButton:!0,prevButton:!0,nextButton:!0,defaultSelect:!0,scrollMonth:!0,scrollTime:!0,scrollInput:!0,lazyInit:!1,mask:!1,validateOnBlur:!0,allowBlank:!0,yearStart:1950,yearEnd:2050,monthStart:0,monthEnd:11,style:'',id:'',fixed:!1,roundTime:'round',className:'',weekends:[],highlightedDates:[],highlightedPeriods:[],allowDates:[],allowDateRe:null,disabledDates:[],disabledWeekDays:[],yearOffset:0,beforeShowDay:null,enterLikeTab:!0,showApplyButton:!1,insideParent:!1,};var t=null,r=null,f='en',a='en',l={meridiem:['AM','PM']};var s=function(){var i=n.i18n[a],o={days:i.dayOfWeek,daysShort:i.dayOfWeekShort,months:i.months,monthsShort:e.map(i.months,function(e){return e.substring(0,3)})};if(typeof DateFormatter==='function'){t=r=new DateFormatter({dateSettings:e.extend({},l,o)})}},u={moment:{default_options:{format:'YYYY/MM/DD HH:mm',formatDate:'YYYY/MM/DD',formatTime:'HH:mm',},formatter:{parseDate:function(e,t){if(i(t)){return r.parseDate(e,t)};var a=moment(e,t);return a.isValid()?a.toDate():!1},formatDate:function(e,t){if(i(t)){return r.formatDate(e,t)};return moment(e).format(t)},formatMask:function(e){return e.replace(/Y{4}/g,'9999').replace(/Y{2}/g,'99').replace(/M{2}/g,'19').replace(/D{2}/g,'39').replace(/H{2}/g,'29').replace(/m{2}/g,'59').replace(/s{2}/g,'59')},}}};e.datetimepicker={setLocale:function(e){var t=n.i18n[e]?e:f;if(a!==t){a=t;s()}},setDateFormatter:function(a){if(typeof a==='string'&&u.hasOwnProperty(a)){var r=u[a];e.extend(n,r.default_options);t=r.formatter}
else{t=a}},};var o={RFC_2822:'D, d M Y H:i:s O',ATOM:'Y-m-d\TH:i:sP',ISO_8601:'Y-m-d\TH:i:sO',RFC_822:'D, d M y H:i:s O',RFC_850:'l, d-M-y H:i:s T',RFC_1036:'D, d M y H:i:s O',RFC_1123:'D, d M Y H:i:s O',RSS:'D, d M Y H:i:s O',W3C:'Y-m-d\TH:i:sP'};var i=function(e){return Object.values(o).indexOf(e)===-1?!1:!0};e.extend(e.datetimepicker,o);s();if(!window.getComputedStyle){window.getComputedStyle=function(e){this.el=e;this.getPropertyValue=function(t){var a=/(-([a-z]))/g;if(t==='float'){t='styleFloat'};if(a.test(t)){t=t.replace(a,function(e,t,a){return a.toUpperCase()})};return e.currentStyle[t]||null};return this}};if(!Array.prototype.indexOf){Array.prototype.indexOf=function(e,t){var a,n;for(a=(t||0),n=this.length;a<n;a+=1){if(this[a]===e){return a}};return-1}};Date.prototype.countDaysInMonth=function(){return new Date(this.getFullYear(),this.getMonth()+1,0).getDate()};e.fn.xdsoftScroller=function(t,a){return this.each(function(){var n=e(this),d=function(e){var t={x:0,y:0},a;if(e.type==='touchstart'||e.type==='touchmove'||e.type==='touchend'||e.type==='touchcancel'){a=e.originalEvent.touches[0]||e.originalEvent.changedTouches[0];t.x=a.clientX;t.y=a.clientY}
else if(e.type==='mousedown'||e.type==='mouseup'||e.type==='mousemove'||e.type==='mouseover'||e.type==='mouseout'||e.type==='mouseenter'||e.type==='mouseleave'){t.x=e.clientX;t.y=e.clientY};return t},o,i,s,u,r,f=100,l=!1,D=0,m=0,h=0,g=!1,p=0,c=function(){};if(a==='hide'){n.find('.xdsoft_scrollbar').hide();return};if(!e(this).hasClass('xdsoft_scroller_box')){o=n.children().eq(0);i=n[0].clientHeight;s=o[0].offsetHeight;u=e('<div class="xdsoft_scrollbar"></div>');r=e('<div class="xdsoft_scroller"></div>');u.append(r);n.addClass('xdsoft_scroller_box').append(u);c=function(e){var t=d(e).y-D+p;if(t<0){t=0};if(t+r[0].offsetHeight>h){t=h-r[0].offsetHeight};n.trigger('scroll_element.xdsoft_scroller',[f?t/f:0])};r.on('touchstart.xdsoft_scroller mousedown.xdsoft_scroller',function(o){if(!i){n.trigger('resize_scroll.xdsoft_scroller',[a])};D=d(o).y;p=parseInt(r.css('margin-top'),10);h=u[0].offsetHeight;if(o.type==='mousedown'||o.type==='touchstart'){if(t.ownerDocument){e(t.ownerDocument.body).addClass('xdsoft_noselect')};e([t.ownerDocument.body,t.contentWindow]).on('touchend mouseup.xdsoft_scroller',function s(){e([t.ownerDocument.body,t.contentWindow]).off('touchend mouseup.xdsoft_scroller',s).off('mousemove.xdsoft_scroller',c).removeClass('xdsoft_noselect')});e(t.ownerDocument.body).on('mousemove.xdsoft_scroller',c)}
else{g=!0;o.stopPropagation();o.preventDefault()}}).on('touchmove',function(e){if(g){e.preventDefault();c(e)}}).on('touchend touchcancel',function(){g=!1;p=0});n.on('scroll_element.xdsoft_scroller',function(e,t){if(!i){n.trigger('resize_scroll.xdsoft_scroller',[t,!0])};t=t>1?1:(t<0||isNaN(t))?0:t;r.css('margin-top',f*t);setTimeout(function(){o.css('marginTop',-parseInt((o[0].offsetHeight-i)*t,10))},10)}).on('resize_scroll.xdsoft_scroller',function(e,t,a){var d,l;i=n[0].clientHeight;s=o[0].offsetHeight;d=i/s;l=d*u[0].offsetHeight;if(d>1){r.hide()}
else{r.show();r.css('height',parseInt(l>10?l:10,10));f=u[0].offsetHeight-r[0].offsetHeight;if(a!==!0){n.trigger('scroll_element.xdsoft_scroller',[t||Math.abs(parseInt(o.css('marginTop'),10))/(s-i)])}}});n.on('mousewheel',function(e){var t=Math.abs(parseInt(o.css('marginTop'),10));t=t-(e.deltaY*20);if(t<0){t=0};n.trigger('scroll_element.xdsoft_scroller',[t/(s-i)]);e.stopPropagation();return!1});n.on('touchstart',function(e){l=d(e);m=Math.abs(parseInt(o.css('marginTop'),10))});n.on('touchmove',function(e){if(l){e.preventDefault();var t=d(e);n.trigger('scroll_element.xdsoft_scroller',[(m-(t.y-l.y))/(s-i)])}});n.on('touchend touchcancel',function(){l=!1;m=0})};n.trigger('resize_scroll.xdsoft_scroller',[a])})};e.fn.datetimepicker=function(i,o){var c=this,m=48,T=57,h=96,g=105,u=17,p=91,D=46,y=13,S=27,s=8,w=37,M=38,O=39,W=40,v=9,F=116,C=65,P=67,Y=86,A=90,H=89,f=!1,b=!1,r=(e.isPlainObject(i)||!i)?e.extend(!0,{},n,i):e.extend(!0,{},n),k=0,l,x,j=function(e){e.on('open.xdsoft focusin.xdsoft mousedown.xdsoft touchstart',function t(){if(e.is(':disabled')||e.data('xdsoft_datetimepicker')){return};clearTimeout(k);k=setTimeout(function(){if(!e.data('xdsoft_datetimepicker')){l(e)};e.off('open.xdsoft focusin.xdsoft mousedown.xdsoft touchstart',t).trigger('open.xdsoft')},100)})};l=function(n){var o=e('<div class="xdsoft_datetimepicker xdsoft_noselect"></div>'),Q=e('<div class="xdsoft_copyright"><a target="_blank" href="http://xdsoft.net/jqplugins/datetimepicker/">xdsoft.net</a></div>'),k=e('<div class="xdsoft_datepicker active"></div>'),p=e('<div class="xdsoft_monthpicker"><button type="button" class="xdsoft_prev"></button><button type="button" class="xdsoft_today_button"></button><div class="xdsoft_label xdsoft_month"><span></span><i></i></div><div class="xdsoft_label xdsoft_year"><span></span><i></i></div><button type="button" class="xdsoft_next"></button></div>'),N=e('<div class="xdsoft_calendar"></div>'),j=e('<div class="xdsoft_timepicker active"><button type="button" class="xdsoft_prev"></button><div class="xdsoft_time_box"></div><button type="button" class="xdsoft_next"></button></div>'),b=j.find('.xdsoft_time_box').eq(0),c=e('<div class="xdsoft_time_variant"></div>'),L=e('<button type="button" class="xdsoft_save_selected blue-gradient-button">Save Selected</button>'),E=e('<div class="xdsoft_select xdsoft_monthselect"><div></div></div>'),R=e('<div class="xdsoft_select xdsoft_yearselect"><div></div></div>'),J=!1,X,V,z,x,I,B=0,l,G;if(r.id){o.attr('id',r.id)};if(r.style){o.attr('style',r.style)};if(r.weeks){o.addClass('xdsoft_showweeks')};if(r.rtl){o.addClass('xdsoft_rtl')};o.addClass('xdsoft_'+r.theme);o.addClass(r.className);p.find('.xdsoft_month span').after(E);p.find('.xdsoft_year span').after(R);p.find('.xdsoft_month,.xdsoft_year').on('touchstart mousedown.xdsoft',function(t){var a=e(this).find('.xdsoft_select').eq(0),o=0,s=0,u=a.is(':visible'),n,i;p.find('.xdsoft_select').hide();if(l.currentTime){o=l.currentTime[e(this).hasClass('xdsoft_month')?'getMonth':'getFullYear']()};a[u?'hide':'show']();for(n=a.find('div.xdsoft_option'),i=0;i<n.length;i+=1){if(n.eq(i).data('value')===o){break}
else{s+=n[0].offsetHeight}};a.xdsoftScroller(r,s/(a.children()[0].offsetHeight-(a[0].clientHeight)));t.stopPropagation();return!1});var q=function(e){var t=e.originalEvent,a=t.touches?t.touches[0]:t;this.touchStartPosition=this.touchStartPosition||a;var n=Math.abs(this.touchStartPosition.clientX-a.clientX),i=Math.abs(this.touchStartPosition.clientY-a.clientY),o=Math.sqrt(n*n+i*i);if(o>r.touchMovedThreshold){this.touchMoved=!0}};p.find('.xdsoft_select').xdsoftScroller(r).on('touchstart mousedown.xdsoft',function(e){var t=e.originalEvent;this.touchMoved=!1;this.touchStartPosition=t.touches?t.touches[0]:t;e.stopPropagation();e.preventDefault()}).on('touchmove','.xdsoft_option',q).on('touchend mousedown.xdsoft','.xdsoft_option',function(){if(!this.touchMoved){if(l.currentTime===undefined||l.currentTime===null){l.currentTime=l.now()};var t=l.currentTime.getFullYear();if(l&&l.currentTime){l.currentTime[e(this).parent().parent().hasClass('xdsoft_monthselect')?'setMonth':'setFullYear'](e(this).data('value'))};e(this).parent().parent().hide();o.trigger('xchange.xdsoft');if(r.onChangeMonth&&e.isFunction(r.onChangeMonth)){r.onChangeMonth.call(o,l.currentTime,o.data('input'))};if(t!==l.currentTime.getFullYear()&&e.isFunction(r.onChangeYear)){r.onChangeYear.call(o,l.currentTime,o.data('input'))}}});o.getValue=function(){return l.getCurrentTime()};o.setOptions=function(a){var i={};r=e.extend(!0,{},r,a);if(a.allowTimes&&e.isArray(a.allowTimes)&&a.allowTimes.length){r.allowTimes=e.extend(!0,[],a.allowTimes)};if(a.weekends&&e.isArray(a.weekends)&&a.weekends.length){r.weekends=e.extend(!0,[],a.weekends)};if(a.allowDates&&e.isArray(a.allowDates)&&a.allowDates.length){r.allowDates=e.extend(!0,[],a.allowDates)};if(a.allowDateRe&&Object.prototype.toString.call(a.allowDateRe)==='[object String]'){r.allowDateRe=new RegExp(a.allowDateRe)};if(a.highlightedDates&&e.isArray(a.highlightedDates)&&a.highlightedDates.length){e.each(a.highlightedDates,function(a,n){var f=e.map(n.split(','),e.trim),s,o=new d(t.parseDate(f[0],r.formatDate),f[1],f[2]),u=t.formatDate(o.date,r.formatDate);if(i[u]!==undefined){s=i[u].desc;if(s&&s.length&&o.desc&&o.desc.length){i[u].desc=s+'\n'+o.desc}}
else{i[u]=o}});r.highlightedDates=e.extend(!0,[],i)};if(a.highlightedPeriods&&e.isArray(a.highlightedPeriods)&&a.highlightedPeriods.length){i=e.extend(!0,[],r.highlightedDates);e.each(a.highlightedPeriods,function(a,n){var o,c,m,s,u,l,h;if(e.isArray(n)){o=n[0];c=n[1];m=n[2];h=n[3]}
else{var f=e.map(n.split(','),e.trim);o=t.parseDate(f[0],r.formatDate);c=t.parseDate(f[1],r.formatDate);m=f[2];h=f[3]}
while(o<=c){s=new d(o,m,h);u=t.formatDate(o,r.formatDate);o.setDate(o.getDate()+1);if(i[u]!==undefined){l=i[u].desc;if(l&&l.length&&s.desc&&s.desc.length){i[u].desc=l+'\n'+s.desc}}
else{i[u]=s}}});r.highlightedDates=e.extend(!0,[],i)};if(a.disabledDates&&e.isArray(a.disabledDates)&&a.disabledDates.length){r.disabledDates=e.extend(!0,[],a.disabledDates)};if(a.disabledWeekDays&&e.isArray(a.disabledWeekDays)&&a.disabledWeekDays.length){r.disabledWeekDays=e.extend(!0,[],a.disabledWeekDays)};if((r.open||r.opened)&&(!r.inline)){n.trigger('open.xdsoft')};if(r.inline){J=!0;o.addClass('xdsoft_inline');n.after(o).hide()};if(r.inverseButton){r.next='xdsoft_prev';r.prev='xdsoft_next'};if(r.datepicker){k.addClass('active')}
else{k.removeClass('active')};if(r.timepicker){j.addClass('active')}
else{j.removeClass('active')};if(r.value){l.setCurrentTime(r.value);if(n&&n.val){n.val(l.str)}};if(isNaN(r.dayOfWeekStart)){r.dayOfWeekStart=0}
else{r.dayOfWeekStart=parseInt(r.dayOfWeekStart,10)%7};if(!r.timepickerScrollbar){b.xdsoftScroller(r,'hide')};if(r.minDate&&/^[\+\-](.*)$/.test(r.minDate)){r.minDate=t.formatDate(l.strToDateTime(r.minDate),r.formatDate)};if(r.maxDate&&/^[\+\-](.*)$/.test(r.maxDate)){r.maxDate=t.formatDate(l.strToDateTime(r.maxDate),r.formatDate)};if(r.minDateTime&&/^\+(.*)$/.test(r.minDateTime)){r.minDateTime=l.strToDateTime(r.minDateTime).dateFormat(r.formatDate)};if(r.maxDateTime&&/^\+(.*)$/.test(r.maxDateTime)){r.maxDateTime=l.strToDateTime(r.maxDateTime).dateFormat(r.formatDate)};L.toggle(r.showApplyButton);p.find('.xdsoft_today_button').css('visibility',!r.todayButton?'hidden':'visible');p.find('.'+r.prev).css('visibility',!r.prevButton?'hidden':'visible');p.find('.'+r.next).css('visibility',!r.nextButton?'hidden':'visible');K(r);if(r.validateOnBlur){n.off('blur.xdsoft').on('blur.xdsoft',function(){if(r.allowBlank&&(!e.trim(e(this).val()).length||(typeof r.mask==='string'&&e.trim(e(this).val())===r.mask.replace(/[0-9]/g,'_')))){e(this).val(null);o.data('xdsoft_datetime').empty()}
else{var i=t.parseDate(e(this).val(),r.format);if(i){e(this).val(t.formatDate(i,r.format))}
else{var a=+([e(this).val()[0],e(this).val()[1]].join('')),n=+([e(this).val()[2],e(this).val()[3]].join(''));if(!r.datepicker&&r.timepicker&&a>=0&&a<24&&n>=0&&n<60){e(this).val([a,n].map(function(e){return e>9?e:'0'+e}).join(':'))}
else{e(this).val(t.formatDate(l.now(),r.format))}};o.data('xdsoft_datetime').setCurrentTime(e(this).val())};o.trigger('changedatetime.xdsoft');o.trigger('close.xdsoft')})};r.dayOfWeekStartPrev=(r.dayOfWeekStart===0)?6:r.dayOfWeekStart-1;o.trigger('xchange.xdsoft').trigger('afterOpen.xdsoft')};o.data('options',r).on('touchstart mousedown.xdsoft',function(e){e.stopPropagation();e.preventDefault();R.hide();E.hide();return!1});b.append(c);b.xdsoftScroller(r);o.on('afterOpen.xdsoft',function(){b.xdsoftScroller(r)});o.append(k).append(j);if(r.withoutCopyright!==!0){o.append(Q)};k.append(p).append(N).append(L);if(r.insideParent){e(n).parent().append(o)}
else{e(r.parentID).append(o)};X=function(){var a=this;a.now=function(e){var t=new Date(),i,n;if(!e&&r.defaultDate){i=a.strToDateTime(r.defaultDate);t.setFullYear(i.getFullYear());t.setMonth(i.getMonth());t.setDate(i.getDate())};t.setFullYear(t.getFullYear());if(!e&&r.defaultTime){n=a.strtotime(r.defaultTime);t.setHours(n.getHours());t.setMinutes(n.getMinutes());t.setSeconds(n.getSeconds());t.setMilliseconds(n.getMilliseconds())};return t};a.isValidDate=function(e){if(Object.prototype.toString.call(e)!=='[object Date]'){return!1};return!isNaN(e.getTime())};a.setCurrentTime=function(e,t){if(typeof e==='string'){a.currentTime=a.strToDateTime(e)}
else if(a.isValidDate(e)){a.currentTime=e}
else if(!e&&!t&&r.allowBlank&&!r.inline){a.currentTime=null}
else{a.currentTime=a.now()};o.trigger('xchange.xdsoft')};a.empty=function(){a.currentTime=null};a.getCurrentTime=function(){return a.currentTime};a.nextMonth=function(){if(a.currentTime===undefined||a.currentTime===null){a.currentTime=a.now()};var t=a.currentTime.getMonth()+1,n;if(t===12){a.currentTime.setFullYear(a.currentTime.getFullYear()+1);t=0};n=a.currentTime.getFullYear();a.currentTime.setDate(Math.min(new Date(a.currentTime.getFullYear(),t+1,0).getDate(),a.currentTime.getDate()));a.currentTime.setMonth(t);if(r.onChangeMonth&&e.isFunction(r.onChangeMonth)){r.onChangeMonth.call(o,l.currentTime,o.data('input'))};if(n!==a.currentTime.getFullYear()&&e.isFunction(r.onChangeYear)){r.onChangeYear.call(o,l.currentTime,o.data('input'))};o.trigger('xchange.xdsoft');return t};a.prevMonth=function(){if(a.currentTime===undefined||a.currentTime===null){a.currentTime=a.now()};var t=a.currentTime.getMonth()-1;if(t===-1){a.currentTime.setFullYear(a.currentTime.getFullYear()-1);t=11};a.currentTime.setDate(Math.min(new Date(a.currentTime.getFullYear(),t+1,0).getDate(),a.currentTime.getDate()));a.currentTime.setMonth(t);if(r.onChangeMonth&&e.isFunction(r.onChangeMonth)){r.onChangeMonth.call(o,l.currentTime,o.data('input'))};o.trigger('xchange.xdsoft');return t};a.getWeekOfYear=function(t){if(r.onGetWeekOfYear&&e.isFunction(r.onGetWeekOfYear)){var n=r.onGetWeekOfYear.call(o,t);if(typeof n!=='undefined'){return n}};var a=new Date(t.getFullYear(),0,1);if(a.getDay()!==4){a.setMonth(0,1+((4-a.getDay()+7)%7))};return Math.ceil((((t-a)/86400000)+a.getDay()+1)/7)};a.strToDateTime=function(e){var n=[],o,i;if(e&&e instanceof Date&&a.isValidDate(e)){return e};n=/^([+-]{1})(.*)$/.exec(e);if(n){n[2]=t.parseDate(n[2],r.formatDate)};if(n&&n[2]){o=n[2].getTime()-(n[2].getTimezoneOffset())*60000;i=new Date((a.now(!0)).getTime()+parseInt(n[1]+'1',10)*o)}
else{i=e?t.parseDate(e,r.format):a.now()};if(!a.isValidDate(i)){i=a.now()};return i};a.strToDate=function(e){if(e&&e instanceof Date&&a.isValidDate(e)){return e};var n=e?t.parseDate(e,r.formatDate):a.now(!0);if(!a.isValidDate(n)){n=a.now(!0)};return n};a.strtotime=function(e){if(e&&e instanceof Date&&a.isValidDate(e)){return e};var n=e?t.parseDate(e,r.formatTime):a.now(!0);if(!a.isValidDate(n)){n=a.now(!0)};return n};a.str=function(){var e=r.format;if(r.yearOffset){e=e.replace('Y',a.currentTime.getFullYear()+r.yearOffset);e=e.replace('y',String(a.currentTime.getFullYear()+r.yearOffset).substring(2,4))};return t.formatDate(a.currentTime,e)};a.currentTime=this.now()};l=new X();L.on('touchend click',function(e){e.preventDefault();o.data('changed',!0);l.setCurrentTime(U());n.val(l.str());o.trigger('close.xdsoft')});p.find('.xdsoft_today_button').on('touchend mousedown.xdsoft',function(){o.data('changed',!0);l.setCurrentTime(0,!0);o.trigger('afterOpen.xdsoft')}).on('dblclick.xdsoft',function(){var e=l.getCurrentTime(),t,a;e=new Date(e.getFullYear(),e.getMonth(),e.getDate());t=l.strToDate(r.minDate);t=new Date(t.getFullYear(),t.getMonth(),t.getDate());if(e<t){return};a=l.strToDate(r.maxDate);a=new Date(a.getFullYear(),a.getMonth(),a.getDate());if(e>a){return};n.val(l.str());n.trigger('change');o.trigger('close.xdsoft')});p.find('.xdsoft_prev,.xdsoft_next').on('touchend mousedown.xdsoft',function(){var t=e(this),a=0,n=!1;(function i(e){if(t.hasClass(r.next)){l.nextMonth()}
else if(t.hasClass(r.prev)){l.prevMonth()};if(r.monthChangeSpinner){if(!n){a=setTimeout(i,e||100)}}}(500));e([r.ownerDocument.body,r.contentWindow]).on('touchend mouseup.xdsoft',function o(){clearTimeout(a);n=!0;e([r.ownerDocument.body,r.contentWindow]).off('touchend mouseup.xdsoft',o)})});j.find('.xdsoft_prev,.xdsoft_next').on('touchend mousedown.xdsoft',function(){var a=e(this),n=0,i=!1,t=110;(function o(e){var u=b[0].clientHeight,d=c[0].offsetHeight,s=Math.abs(parseInt(c.css('marginTop'),10));if(a.hasClass(r.next)&&(d-u)-r.timeHeightInTimePicker>=s){c.css('marginTop','-'+(s+r.timeHeightInTimePicker)+'px')}
else if(a.hasClass(r.prev)&&s-r.timeHeightInTimePicker>=0){c.css('marginTop','-'+(s-r.timeHeightInTimePicker)+'px')};b.trigger('scroll_element.xdsoft_scroller',[Math.abs(parseInt(c[0].style.marginTop,10)/(d-u))]);t=(t>10)?10:t-10;if(!i){n=setTimeout(o,e||t)}}(500));e([r.ownerDocument.body,r.contentWindow]).on('touchend mouseup.xdsoft',function s(){clearTimeout(n);i=!0;e([r.ownerDocument.body,r.contentWindow]).off('touchend mouseup.xdsoft',s)})});V=0;o.on('xchange.xdsoft',function(s){clearTimeout(V);V=setTimeout(function(){if(l.currentTime===undefined||l.currentTime===null){l.currentTime=l.now()};var g='',s=new Date(l.currentTime.getFullYear(),l.currentTime.getMonth(),1,12,0,0),u=0,D,O=l.now(),v=!1,b=!1,y=!1,h=!1,S,H,M,j,f,J,d=[],k,W=!0,F='',w,C,P;while(s.getDay()!==r.dayOfWeekStart){s.setDate(s.getDate()-1)};g+='<table><thead><tr>';if(r.weeks){g+='<th></th>'};for(D=0;D<7;D+=1){g+='<th>'+r.i18n[a].dayOfWeekShort[(D+r.dayOfWeekStart)%7]+'</th>'};g+='</tr></thead>';g+='<tbody>';if(r.maxDate!==!1){v=l.strToDate(r.maxDate);v=new Date(v.getFullYear(),v.getMonth(),v.getDate(),23,59,59,999)};if(r.minDate!==!1){b=l.strToDate(r.minDate);b=new Date(b.getFullYear(),b.getMonth(),b.getDate())};if(r.minDateTime!==!1){y=l.strToDate(r.minDateTime);y=new Date(y.getFullYear(),y.getMonth(),y.getDate(),y.getHours(),y.getMinutes(),y.getSeconds())};if(r.maxDateTime!==!1){h=l.strToDate(r.maxDateTime);h=new Date(h.getFullYear(),h.getMonth(),h.getDate(),h.getHours(),h.getMinutes(),h.getSeconds())};var A;if(h!==!1){A=((h.getFullYear()*12)+h.getMonth())*31+h.getDate()}
while(u<l.currentTime.countDaysInMonth()||s.getDay()!==r.dayOfWeekStart||l.currentTime.getMonth()===s.getMonth()){d=[];u+=1;H=s.getDay();M=s.getDate();j=s.getFullYear();f=s.getMonth();J=l.getWeekOfYear(s);P='';d.push('xdsoft_date');if(r.beforeShowDay&&e.isFunction(r.beforeShowDay.call)){k=r.beforeShowDay.call(o,s)}
else{k=null};if(r.allowDateRe&&Object.prototype.toString.call(r.allowDateRe)==='[object RegExp]'){if(!r.allowDateRe.test(t.formatDate(s,r.formatDate))){d.push('xdsoft_disabled')}};if(r.allowDates&&r.allowDates.length>0){if(r.allowDates.indexOf(t.formatDate(s,r.formatDate))===-1){d.push('xdsoft_disabled')}};var L=((s.getFullYear()*12)+s.getMonth())*31+s.getDate();if((v!==!1&&s>v)||(y!==!1&&s<y)||(b!==!1&&s<b)||(h!==!1&&L>A)||(k&&k[0]===!1)){d.push('xdsoft_disabled')};if(r.disabledDates.indexOf(t.formatDate(s,r.formatDate))!==-1){d.push('xdsoft_disabled')};if(r.disabledWeekDays.indexOf(H)!==-1){d.push('xdsoft_disabled')};if(n.is('[disabled]')){d.push('xdsoft_disabled')};if(k&&k[1]!==''){d.push(k[1])};if(l.currentTime.getMonth()!==f){d.push('xdsoft_other_month')};if((r.defaultSelect||o.data('changed'))&&t.formatDate(l.currentTime,r.formatDate)===t.formatDate(s,r.formatDate)){d.push('xdsoft_current')};if(t.formatDate(O,r.formatDate)===t.formatDate(s,r.formatDate)){d.push('xdsoft_today')};if(s.getDay()===0||s.getDay()===6||r.weekends.indexOf(t.formatDate(s,r.formatDate))!==-1){d.push('xdsoft_weekend')};if(r.highlightedDates[t.formatDate(s,r.formatDate)]!==undefined){S=r.highlightedDates[t.formatDate(s,r.formatDate)];d.push(S.style===undefined?'xdsoft_highlighted_default':S.style);P=S.desc===undefined?'':S.desc};if(r.beforeShowDay&&e.isFunction(r.beforeShowDay)){d.push(r.beforeShowDay(s))};if(W){g+='<tr>';W=!1;if(r.weeks){g+='<th>'+J+'</th>'}};g+='<td data-date="'+M+'" data-month="'+f+'" data-year="'+j+'" class="xdsoft_date xdsoft_day_of_week'+s.getDay()+' '+d.join(' ')+'" title="'+P+'"><div>'+M+'</div></td>';if(s.getDay()===r.dayOfWeekStartPrev){g+='</tr>';W=!0};s.setDate(M+1)};g+='</tbody></table>';N.html(g);p.find('.xdsoft_label span').eq(0).text(r.i18n[a].months[l.currentTime.getMonth()]);p.find('.xdsoft_label span').eq(1).text(l.currentTime.getFullYear()+r.yearOffset);F='';w='';f='';var T=0;if(r.minTime!==!1){var m=l.strtotime(r.minTime);T=60*m.getHours()+m.getMinutes()};var x=24*60;if(r.maxTime!==!1){var m=l.strtotime(r.maxTime);x=60*m.getHours()+m.getMinutes()};if(r.minDateTime!==!1){var m=l.strToDateTime(r.minDateTime),I=t.formatDate(l.currentTime,r.formatDate)===t.formatDate(m,r.formatDate);if(I){var f=60*m.getHours()+m.getMinutes();if(f>T)T=f}};if(r.maxDateTime!==!1){var m=l.strToDateTime(r.maxDateTime),z=t.formatDate(l.currentTime,r.formatDate)===t.formatDate(m,r.formatDate);if(z){var f=60*m.getHours()+m.getMinutes();if(f<x)x=f}};C=function(a,i){var s=l.now(),u,c=r.allowTimes&&e.isArray(r.allowTimes)&&r.allowTimes.length;s.setHours(a);a=parseInt(s.getHours(),10);s.setMinutes(i);i=parseInt(s.getMinutes(),10);d=[];var f=60*a+i;if(n.is('[disabled]')||(f>=x)||(f<T)){d.push('xdsoft_disabled')};u=new Date(l.currentTime);u.setHours(parseInt(l.currentTime.getHours(),10));if(!c){u.setMinutes(Math[r.roundTime](l.currentTime.getMinutes()/r.step)*r.step)};if((r.initTime||r.defaultSelect||o.data('changed'))&&u.getHours()===parseInt(a,10)&&((!c&&r.step>59)||u.getMinutes()===parseInt(i,10))){if(r.defaultSelect||o.data('changed')){d.push('xdsoft_current')}
else if(r.initTime){d.push('xdsoft_init_time')}};if(parseInt(O.getHours(),10)===parseInt(a,10)&&parseInt(O.getMinutes(),10)===parseInt(i,10)){d.push('xdsoft_today')};F+='<div class="xdsoft_time '+d.join(' ')+'" data-hour="'+a+'" data-minute="'+i+'">'+t.formatDate(s,r.formatTime)+'</div>'};if(!r.allowTimes||!e.isArray(r.allowTimes)||!r.allowTimes.length){for(u=0,D=0;u<(r.hours12?12:24);u+=1){for(D=0;D<60;D+=r.step){var Y=u*60+D;if(Y<T)continue;if(Y>=x)continue;w=(u<10?'0':'')+u;f=(D<10?'0':'')+D;C(w,f)}}}
else{for(u=0;u<r.allowTimes.length;u+=1){w=l.strtotime(r.allowTimes[u]).getHours();f=l.strtotime(r.allowTimes[u]).getMinutes();C(w,f)}};c.html(F);i='';for(u=parseInt(r.yearStart,10);u<=parseInt(r.yearEnd,10);u+=1){i+='<div class="xdsoft_option '+(l.currentTime.getFullYear()===u?'xdsoft_current':'')+'" data-value="'+u+'">'+(u+r.yearOffset)+'</div>'};R.children().eq(0).html(i);for(u=parseInt(r.monthStart,10),i='';u<=parseInt(r.monthEnd,10);u+=1){i+='<div class="xdsoft_option '+(l.currentTime.getMonth()===u?'xdsoft_current':'')+'" data-value="'+u+'">'+r.i18n[a].months[u]+'</div>'};E.children().eq(0).html(i);e(o).trigger('generate.xdsoft')},10);s.stopPropagation()}).on('afterOpen.xdsoft',function(){if(r.timepicker){var e,t,a,n;if(c.find('.xdsoft_current').length){e='.xdsoft_current'}
else if(c.find('.xdsoft_init_time').length){e='.xdsoft_init_time'};if(e){t=b[0].clientHeight;a=c[0].offsetHeight;n=c.find(e).index()*r.timeHeightInTimePicker+1;if((a-t)<n){n=a-t};b.trigger('scroll_element.xdsoft_scroller',[parseInt(n,10)/(a-t)])}
else{b.trigger('scroll_element.xdsoft_scroller',[0])}}});z=0;N.on('touchend click.xdsoft','td',function(t){t.stopPropagation();z+=1;var i=e(this),a=l.currentTime;if(a===undefined||a===null){l.currentTime=l.now();a=l.currentTime};if(i.hasClass('xdsoft_disabled')){return!1};a.setDate(1);a.setFullYear(i.data('year'));a.setMonth(i.data('month'));a.setDate(i.data('date'));o.trigger('select.xdsoft',[a]);n.val(l.str());if(r.onSelectDate&&e.isFunction(r.onSelectDate)){r.onSelectDate.call(o,l.currentTime,o.data('input'),t)};o.data('changed',!0);o.trigger('xchange.xdsoft');o.trigger('changedatetime.xdsoft');if((z>1||(r.closeOnDateSelect===!0||(r.closeOnDateSelect===!1&&!r.timepicker)))&&!r.inline){o.trigger('close.xdsoft')};setTimeout(function(){z=0},200)});c.on('touchstart','div',function(e){this.touchMoved=!1}).on('touchmove','div',q).on('touchend click.xdsoft','div',function(t){if(!this.touchMoved){t.stopPropagation();var n=e(this),a=l.currentTime;if(a===undefined||a===null){l.currentTime=l.now();a=l.currentTime};if(n.hasClass('xdsoft_disabled')){return!1};a.setHours(n.data('hour'));a.setMinutes(n.data('minute'));o.trigger('select.xdsoft',[a]);o.data('input').val(l.str());if(r.onSelectTime&&e.isFunction(r.onSelectTime)){r.onSelectTime.call(o,l.currentTime,o.data('input'),t)};o.data('changed',!0);o.trigger('xchange.xdsoft');o.trigger('changedatetime.xdsoft');if(r.inline!==!0&&r.closeOnTimeSelect===!0){o.trigger('close.xdsoft')}}});k.on('mousewheel.xdsoft',function(e){if(!r.scrollMonth){return!0};if(e.deltaY<0){l.nextMonth()}
else{l.prevMonth()};return!1});n.on('mousewheel.xdsoft',function(e){if(!r.scrollInput){return!0};if(!r.datepicker&&r.timepicker){x=c.find('.xdsoft_current').length?c.find('.xdsoft_current').eq(0).index():0;if(x+e.deltaY>=0&&x+e.deltaY<c.children().length){x+=e.deltaY};if(c.children().eq(x).length){c.children().eq(x).trigger('mousedown')};return!1};if(r.datepicker&&!r.timepicker){k.trigger(e,[e.deltaY,e.deltaX,e.deltaY]);if(n.val){n.val(l.str())};o.trigger('changedatetime.xdsoft');return!1}});o.on('changedatetime.xdsoft',function(t){if(r.onChangeDateTime&&e.isFunction(r.onChangeDateTime)){var a=o.data('input');r.onChangeDateTime.call(o,l.currentTime,a,t);delete r.value;a.trigger('change')}}).on('generate.xdsoft',function(){if(r.onGenerate&&e.isFunction(r.onGenerate)){r.onGenerate.call(o,l.currentTime,o.data('input'))};if(J){o.trigger('afterOpen.xdsoft');J=!1}}).on('click.xdsoft',function(e){e.stopPropagation()});x=0;G=function(e,t){do{e=e.parentNode;if(!e||t(e)===!1){break}}
while(e.nodeName!=='HTML');};I=function(){var i,n,t,a,f,g,h,u,d,l,c,m,s;u=o.data('input');i=u.offset();n=u[0];l='top';t=(i.top+n.offsetHeight)-1;a=i.left;f='absolute';d=e(r.contentWindow).width();m=e(r.contentWindow).height();s=e(r.contentWindow).scrollTop();if((r.ownerDocument.documentElement.clientWidth-i.left)<k.parent().outerWidth(!0)){var p=k.parent().outerWidth(!0)-n.offsetWidth;a=a-p};if(u.parent().css('direction')==='rtl'){a-=(o.outerWidth()-u.outerWidth())};if(r.fixed){t-=s;a-=e(r.contentWindow).scrollLeft();f='fixed'}
else{h=!1;G(n,function(e){if(e===null){return!1};if(r.contentWindow.getComputedStyle(e).getPropertyValue('position')==='fixed'){h=!0;return!1}});if(h&&!r.insideParent){f='fixed';if(t+o.outerHeight()>m+s){l='bottom';t=(m+s)-i.top}
else{t-=s}}
else{if(t+o[0].offsetHeight>m+s){t=i.top-o[0].offsetHeight+1}};if(t<0){t=0};if(a+n.offsetWidth>d){a=d-n.offsetWidth}};g=o[0];G(g,function(e){var t;t=r.contentWindow.getComputedStyle(e).getPropertyValue('position');if(t==='relative'&&d>=e.offsetWidth){a=a-((d-e.offsetWidth)/2);return!1}});c={position:f,left:r.insideParent?n.offsetLeft:a,top:'',bottom:''};if(r.insideParent){c[l]=n.offsetTop+n.offsetHeight}
else{c[l]=t};o.css(c)};o.on('open.xdsoft',function(t){var a=!0;if(r.onShow&&e.isFunction(r.onShow)){a=r.onShow.call(o,l.currentTime,o.data('input'),t)};if(a!==!1){o.show();I();e(r.contentWindow).off('resize.xdsoft',I).on('resize.xdsoft',I);if(r.closeOnWithoutClick){e([r.ownerDocument.body,r.contentWindow]).on('touchstart mousedown.xdsoft',function n(){o.trigger('close.xdsoft');e([r.ownerDocument.body,r.contentWindow]).off('touchstart mousedown.xdsoft',n)})}}}).on('close.xdsoft',function(t){var a=!0;p.find('.xdsoft_month,.xdsoft_year').find('.xdsoft_select').hide();if(r.onClose&&e.isFunction(r.onClose)){a=r.onClose.call(o,l.currentTime,o.data('input'),t)};if(a!==!1&&!r.opened&&!r.inline){o.hide()};t.stopPropagation()}).on('toggle.xdsoft',function(){if(o.is(':visible')){o.trigger('close.xdsoft')}
else{o.trigger('open.xdsoft')}}).data('input',n);B=0;o.data('xdsoft_datetime',l);o.setOptions(r);function U(){var e=!1,t;if(r.startDate){e=l.strToDate(r.startDate)}
else{e=r.value||((n&&n.val&&n.val())?n.val():'');if(e){e=l.strToDateTime(e);if(r.yearOffset){e=new Date(e.getFullYear()-r.yearOffset,e.getMonth(),e.getDate(),e.getHours(),e.getMinutes(),e.getSeconds(),e.getMilliseconds())}}
else if(r.defaultDate){e=l.strToDateTime(r.defaultDate);if(r.defaultTime){t=l.strtotime(r.defaultTime);e.setHours(t.getHours());e.setMinutes(t.getMinutes())}}};if(e&&l.isValidDate(e)){o.data('changed',!0)}
else{e=''};return e||0};function K(a){var r=function(e,t){var a=e.replace(/([\[\]\/\{\}\(\)\-\.\+]{1})/g,'\\$1').replace(/_/g,'{digit+}').replace(/([0-9]{1})/g,'{digit$1}').replace(/\{digit([0-9]{1})\}/g,'[0-$1_]{1}').replace(/\{digit[\+]\}/g,'[0-9_]{1}');return(new RegExp(a)).test(t)},o=function(e){try{if(a.ownerDocument.selection&&a.ownerDocument.selection.createRange){var t=a.ownerDocument.selection.createRange();return t.getBookmark().charCodeAt(2)-2};if(e.setSelectionRange){return e.selectionStart}}catch(n){return 0}},i=function(e,t){e=(typeof e==='string'||e instanceof String)?a.ownerDocument.getElementById(e):e;if(!e){return!1};if(e.createTextRange){var n=e.createTextRange();n.collapse(!0);n.moveEnd('character',t);n.moveStart('character',t);n.select();return!0};if(e.setSelectionRange){e.setSelectionRange(t,t);return!0};return!1};if(a.mask){n.off('keydown.xdsoft')};if(a.mask===!0){if(t.formatMask){a.mask=t.formatMask(a.format)}
else{a.mask=a.format.replace(/Y/g,'9999').replace(/F/g,'9999').replace(/m/g,'19').replace(/d/g,'39').replace(/H/g,'29').replace(/i/g,'59').replace(/s/g,'59')}};if(e.type(a.mask)==='string'){if(!r(a.mask,n.val())){n.val(a.mask.replace(/[0-9]/g,'_'));i(n[0],0)};n.on('paste.xdsoft',function(t){var d=t.clipboardData||t.originalEvent.clipboardData||window.clipboardData,u=d.getData('text'),o=this.value,s=this.selectionStart,f=o.substr(0,s),l=o.substr(s+u.length);o=f+u+l;s+=u.length;if(r(a.mask,o)){this.value=o;i(this,s)}
else if(e.trim(o)===''){this.value=a.mask.replace(/[0-9]/g,'_')}
else{n.trigger('error_input.xdsoft')};t.preventDefault();return!1});n.on('keydown.xdsoft',function(t){var l=this.value,d=t.which,o=this.selectionStart,x=this.selectionEnd,c=o!==x,p;if(((d>=m&&d<=T)||(d>=h&&d<=g))||(d===s||d===D)){p=(d===s||d===D)?'_':String.fromCharCode((h<=d&&d<=g)?d-m:d);if(d===s&&o&&!c){o-=1}
while(!0){var V=a.mask.substr(o,1),B=o<a.mask.length,G=o>0,U=/[^0-9_]/,q=U.test(V),X=q&&B&&G;if(!X)break;o+=(d===s&&!c)?-1:1};if(t.metaKey){o=0;c=!0};if(c){var b=x-o,k=a.mask.replace(/[0-9]/g,'_'),I=k.substr(o,b),N=I.substr(1),L=l.substr(0,o),E=p+N,R=l.substr(o+b);l=L+E+R}
else{var j=l.substr(0,o),J=p,z=l.substr(o+1);l=j+J+z};if(e.trim(l)===''){l=k}
else{if(o===a.mask.length){t.preventDefault();return!1}};o+=(d===s)?0:1;while(/[^0-9_]/.test(a.mask.substr(o,1))&&o<a.mask.length&&o>0){o+=(d===s)?0:1};if(r(a.mask,l)){this.value=l;i(this,o)}
else if(e.trim(l)===''){this.value=a.mask.replace(/[0-9]/g,'_')}
else{n.trigger('error_input.xdsoft')}}
else{if(([C,P,Y,A,H].indexOf(d)!==-1&&f)||[S,M,W,w,O,F,u,v,y].indexOf(d)!==-1){return!0}};t.preventDefault();return!1})}};l.setCurrentTime(U());n.data('xdsoft_datetimepicker',o).on('open.xdsoft focusin.xdsoft mousedown.xdsoft touchstart',function(){if(n.is(':disabled')||(n.data('xdsoft_datetimepicker').is(':visible')&&r.closeOnInputClick)){return};if(!r.openOnFocus){return};clearTimeout(B);B=setTimeout(function(){if(n.is(':disabled')){return};J=!0;l.setCurrentTime(U(),!0);if(r.mask){K(r)};o.trigger('open.xdsoft')},100)}).on('keydown.xdsoft',function(t){var a,n=t.which;if([y].indexOf(n)!==-1&&r.enterLikeTab){a=e('input:visible,textarea:visible,button:visible,a:visible');o.trigger('close.xdsoft');a.eq(a.index(this)+1).focus();return!1};if([v].indexOf(n)!==-1){o.trigger('close.xdsoft');return!0}}).on('blur.xdsoft',function(){o.trigger('close.xdsoft')})};x=function(t){var a=t.data('xdsoft_datetimepicker');if(a){a.data('xdsoft_datetime',null);a.remove();t.data('xdsoft_datetimepicker',null).off('.xdsoft');e(r.contentWindow).off('resize.xdsoft');e([r.contentWindow,r.ownerDocument.body]).off('mousedown.xdsoft touchstart');if(t.unmousewheel){t.unmousewheel()}}};e(r.ownerDocument).off('keydown.xdsoftctrl keyup.xdsoftctrl').off('keydown.xdsoftcmd keyup.xdsoftcmd').on('keydown.xdsoftctrl',function(e){if(e.keyCode===u){f=!0}}).on('keyup.xdsoftctrl',function(e){if(e.keyCode===u){f=!1}}).on('keydown.xdsoftcmd',function(e){if(e.keyCode===p){b=!0}}).on('keyup.xdsoftcmd',function(e){if(e.keyCode===p){b=!1}});this.each(function(){var a=e(this).data('xdsoft_datetimepicker'),n;if(a){if(e.type(i)==='string'){switch(i){case'show':e(this).select().focus();a.trigger('open.xdsoft');break;case'hide':a.trigger('close.xdsoft');break;case'toggle':a.trigger('toggle.xdsoft');break;case'destroy':x(e(this));break;case'reset':this.value=this.defaultValue;if(!this.value||!a.data('xdsoft_datetime').isValidDate(t.parseDate(this.value,r.format))){a.data('changed',!1)};a.data('xdsoft_datetime').setCurrentTime(this.value);break;case'validate':n=a.data('input');n.trigger('blur.xdsoft');break;default:if(a[i]&&e.isFunction(a[i])){c=a[i](o)}}}
else{a.setOptions(i)};return 0};if(e.type(i)!=='string'){if(!r.lazyInit||r.open||r.inline){l(e(this))}
else{j(e(this))}}});return c};e.fn.datetimepicker.defaults=n;function d(e,t,a){'use strict';this.date=e;this.desc=t;this.style=a}};(function(e){if(typeof define==='function'&&define.amd){define(['jquery','jquery-mousewheel'],e)}
else if(typeof exports==='object'){module.exports=e(require('jquery'))}
else{e(jQuery)}}(datetimepickerFactory));
/*!
 * jQuery Mousewheel 3.1.13
 *
 * Copyright jQuery Foundation and other contributors
 * Released under the MIT license
 * http://jquery.org/license
 */
(function(e){if(typeof define==='function'&&define.amd){define(['jquery'],e)}
else if(typeof exports==='object'){module.exports=e}
else{e(jQuery)}}(function(e){var s=['wheel','mousewheel','DOMMouseScroll','MozMousePixelScroll'],n=('onwheel' in document||document.documentMode>=9)?['wheel']:['mousewheel','DomMouseScroll','MozMousePixelScroll'],d=Array.prototype.slice,r,t;if(e.event.fixHooks){for(var o=s.length;o;){e.event.fixHooks[s[--o]]=e.event.mouseHooks}};var a=e.event.special.mousewheel={version:'3.1.12',setup:function(){if(this.addEventListener){for(var t=n.length;t;){this.addEventListener(n[--t],i,!1)}}
else{this.onmousewheel=i};e.data(this,'mousewheel-line-height',a.getLineHeight(this));e.data(this,'mousewheel-page-height',a.getPageHeight(this))},teardown:function(){if(this.removeEventListener){for(var t=n.length;t;){this.removeEventListener(n[--t],i,!1)}}
else{this.onmousewheel=null};e.removeData(this,'mousewheel-line-height');e.removeData(this,'mousewheel-page-height')},getLineHeight:function(t){var n=e(t),a=n['offsetParent' in e.fn?'offsetParent':'parent']();if(!a.length){a=e('body')};return parseInt(a.css('fontSize'),10)||parseInt(n.css('fontSize'),10)||16},getPageHeight:function(t){return e(t).height()},settings:{adjustOldDeltas:!0,normalizeOffset:!0}};e.fn.extend({mousewheel:function(e){return e?this.bind('mousewheel',e):this.trigger('mousewheel')},unmousewheel:function(e){return this.unbind('mousewheel',e)}});function i(n){var i=n||window.event,p=d.call(arguments,1),l=0,s=0,o=0,c=0,D=0,y=0;n=e.event.fix(i);n.type='mousewheel';if('detail' in i){o=i.detail*-1};if('wheelDelta' in i){o=i.wheelDelta};if('wheelDeltaY' in i){o=i.wheelDeltaY};if('wheelDeltaX' in i){s=i.wheelDeltaX*-1};if('axis' in i&&i.axis===i.HORIZONTAL_AXIS){s=o*-1;o=0};l=o===0?s:o;if('deltaY' in i){o=i.deltaY*-1;l=o};if('deltaX' in i){s=i.deltaX;if(o===0){l=s*-1}};if(o===0&&s===0){return};if(i.deltaMode===1){var h=e.data(this,'mousewheel-line-height');l*=h;o*=h;s*=h}
else if(i.deltaMode===2){var m=e.data(this,'mousewheel-page-height');l*=m;o*=m;s*=m};c=Math.max(Math.abs(o),Math.abs(s));if(!t||c<t){t=c;if(u(i,c)){t/=40}};if(u(i,c)){l/=40;s/=40;o/=40};l=Math[l>=1?'floor':'ceil'](l/t);s=Math[s>=1?'floor':'ceil'](s/t);o=Math[o>=1?'floor':'ceil'](o/t);if(a.settings.normalizeOffset&&this.getBoundingClientRect){var g=this.getBoundingClientRect();D=n.clientX-g.left;y=n.clientY-g.top};n.deltaX=s;n.deltaY=o;n.deltaFactor=t;n.offsetX=D;n.offsetY=y;n.deltaMode=0;p.unshift(n,l,s,o);if(r){clearTimeout(r)};r=setTimeout(f,200);return(e.event.dispatch||e.event.handle).apply(this,p)};function f(){t=null};function u(e,t){return a.settings.adjustOldDeltas&&e.type==='mousewheel'&&t%120===0}}));